﻿
namespace DeleteFromEntitySet.Web
{
	using System.Data;
    using System.Linq;
    using System.ServiceModel.DomainServices.EntityFramework;
    using System.ServiceModel.DomainServices.Hosting;


	// Implements application logic using the ChinookEntities context.
    // TODO: Add your application logic to these methods or in additional methods.
    // TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
    // Also consider adding roles to restrict access as appropriate.
    // [RequiresAuthentication]
    [EnableClientAccess()]
    public class ChinookService : LinqToEntitiesDomainService<ChinookEntities>
    {

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Albums' query.
        public IQueryable<Album> GetAlbums()
        {
            return this.ObjectContext.Albums.OrderBy(a => a.AlbumId);
        }

        public void InsertAlbum(Album album)
        {
            if ((album.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(album, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Albums.AddObject(album);
            }
        }

        public void UpdateAlbum(Album currentAlbum)
        {
            this.ObjectContext.Albums.AttachAsModified(currentAlbum, this.ChangeSet.GetOriginal(currentAlbum));
        }

        public void DeleteAlbum(Album album)
        {
            if ((album.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Albums.Attach(album);
            }
            this.ObjectContext.Albums.DeleteObject(album);
        }

        // TODO:
        // Consider constraining the results of your query method.  If you need additional input you can
        // add parameters to this method or create additional query methods with different names.
        // To support paging you will need to add ordering to the 'Artists' query.
        public IQueryable<Artist> GetArtists()
        {
            return this.ObjectContext.Artists.Include("Albums").OrderBy(a => a.ArtistId);
        }

        public void InsertArtist(Artist artist)
        {
            if ((artist.EntityState != EntityState.Detached))
            {
                this.ObjectContext.ObjectStateManager.ChangeObjectState(artist, EntityState.Added);
            }
            else
            {
                this.ObjectContext.Artists.AddObject(artist);
            }
        }

        public void UpdateArtist(Artist currentArtist)
        {
            this.ObjectContext.Artists.AttachAsModified(currentArtist, this.ChangeSet.GetOriginal(currentArtist));
        }

        public void DeleteArtist(Artist artist)
        {
            if ((artist.EntityState == EntityState.Detached))
            {
                this.ObjectContext.Artists.Attach(artist);
            }
            this.ObjectContext.Artists.DeleteObject(artist);
        }
    }
}


