﻿using System.ServiceModel.DomainServices.Client;

namespace DeleteFromEntitySet
{
	public class EntityCollectionView<TEntity> : EntityCollectionViewBase<TEntity> where TEntity : Entity, new()
	{
		public EntityCollectionView(EntityCollection<TEntity> entityCollection)
			: base(entityCollection,
			  new EntityCollectionViewDelegates<TEntity>
			  {
				  Add = entityCollection.Add,
				  Remove = entityCollection.Remove,
				  CanAdd = () => true,
				  CanRemove = () => true,
				  Count = () => entityCollection.Count
			  })
		{
		}
	}
}
