﻿using System.ServiceModel.DomainServices.Client;

namespace DeleteFromEntitySet
{
	public class EntitySetCollectionView<TEntity> : EntityCollectionViewBase<TEntity> where TEntity : Entity, new()
	{
		public EntitySetCollectionView(EntitySet<TEntity> entitySet)
			: base(entitySet,
			  new EntityCollectionViewDelegates<TEntity>
			  {
				  Add = entitySet.Add,
				  Remove = entitySet.Remove,
				  CanAdd = () => entitySet.CanAdd,
				  CanRemove = () => entitySet.CanRemove,
				  Count = () => entitySet.Count
			  })
		{
		}
	}
}
